using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ReaderB;
using System.Resources;
using System.Reflection;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace HFReaderDemoCSharp
{
    public partial class MainFrmHFReader : Form
    {
        private byte readerAddr = 0xff;
        private int portFrmIndex = -1;
        private byte[] UL_SNR = new byte[7];
        private byte[] SNR = new byte[4];
        private byte[] PUPI = new byte[4];
        private bool fAppClose = false;


        public static ResourceManager rm;
        private bool fIsTestMode = false;          //Ƿڽвģʽ
        private string DSFIDAndUIDList;            //洢ӿʼѯ鵽յ0E֮DSFID,UID 
        private byte totalCardNumber = 0;
        private bool ISO15693MODE = true;
        private bool ISO14443BMODE = false;
        private bool ISO14443AMODE = false;

        private const byte OK = 0x00;
        private const byte lengthError = 0x01;
        private const byte operationNotSupport = 0x02;
        private const byte dataRangError = 0x03;
        private const byte cmdNotOperation = 0x04;
        private const byte RfClosed = 0x05;
        private const byte EEPROM = 0x06;
        private const byte timeOut = 0x0a;
        private const byte moreUID = 0x0b;
        private const byte ISOError = 0x0c;
        private const byte noElectronicTag = 0x0e;
        private const byte operationError = 0x0f;
        private const byte cmdNotSupport = 0x01;
        private const byte cmdNotIdentify = 0x02;
        private const byte unknownError = 0x0f;
        private const byte blockError = 0x10;
        private const byte blockLockedAndCntLock = 0x11;
        private const byte blockLockedAndCntWrite = 0x12;
        private const byte blockCntOperate = 0x13;
        private const byte blockCntLock = 0x14;
        private const byte communicationErr = 0x30;
        private const byte retCRCErr = 0x31;
        private const byte retDataErr = 0x32;
        private const byte communicationBusy = 0x33;
        private const byte executeCmdBusy = 0x34;
        private const byte comPortOpened = 0x35;
        private const byte comPortClose = 0x36;
        private const byte invalidHandle = 0x37;
        private const byte invalidPort = 0x38;
        private int fopencomport = -1;

        public MainFrmHFReader()
        {
            InitializeComponent();
            InitializeComboBox();
            DisableButton();
        }

        private void InitializeComboBox()
        {
            cbComPortList.SelectedIndex = 0;
            cbLEDOffTime.SelectedIndex = 0;
            cbLEDOnTime.SelectedIndex = 0;
            cbLEDRepeatTimes.SelectedIndex = 0;
            cbBuzzerOffTime.SelectedIndex = 0;
            cbBuzzerOnTime.SelectedIndex = 0;
            cbBuzzerRepeatTimes.SelectedIndex = 0;
            cbInventoryScanTimeToWrite.SelectedIndex = 27;
            cbb14443AKeyBlockNumber.SelectedIndex = 0;
            cbb14443ARWBlockNumber.SelectedIndex = 0;
            cbb14443ARWSector.SelectedIndex = 0;
            cbb14443ABlockNum.SelectedIndex = 1;
            cbbSector2.SelectedIndex = 0;
            cbb14443BCID.SelectedIndex = 0;
            cbb14443BPCDDelay.SelectedIndex = 0;
            cbb14443BPCDTransDataDelay.SelectedIndex = 0;
            cbb14443BSpeedRToT.SelectedIndex = 0;
            cbb14443BSpeedTToR.SelectedIndex = 0;
            cbb14443BPCDRcvMaxLen.SelectedIndex = 0;
            cbb14443BTrspCMDLen.SelectedIndex = 0;
            cbb14443BTrspRSPLen.SelectedIndex = 0;
            cbb14443BTimeM.SelectedIndex = 0;
            cbb14443BTimeN.SelectedIndex = 0;
        }

        private void DisableButton()
        {
            btnWriteSingleBlock.Enabled = false;
            btnReadSingleBlock.Enabled = false;
            btnGetReaderInfo.Enabled = false;
            btnContinueInventoryScanWithAFI.Enabled = false;
            btnContinueInventoryScanNoAFI.Enabled = false;
            btnNewInventoryScanWithAFI.Enabled = false;
            btnNewInventoryScanNoAFI.Enabled = false;
            btnStayQuite.Enabled = false;
            btnInventoryWithAFI.Enabled = false;
            btnInventoryNoAFI.Enabled = false;
            btnReadMultiBlock.Enabled = false;
            btnCloseRF.Enabled = false;
            btnLcokBlock.Enabled = false;
            btnOpenRF.Enabled = false;
            btnResetToReady.Enabled = false;
            btnSelect.Enabled = false;
            btnGetSystemInfo.Enabled = false;
            btnLockAFI.Enabled = false;
            btnWriteAFI.Enabled = false;
            btnLockDSFID.Enabled = false;
            btnWriteDSFID.Enabled = false;
            btnWriteAddress.Enabled = false;
            btnWriteInventoryScanTime.Enabled = false;
            btnSetLED.Enabled = false;
            btnSetBuzzer.Enabled = false;
            btnChangeToISO15693.Enabled = false;
            btnStopTestMode.Enabled = false;
            btnStartTestMode.Enabled = false;
            btnChangeToISO14443A.Enabled = false;
            btn14443ACloseRF.Enabled = false;
            btn14443AOpenRF.Enabled = false;
            btn14443AAuth2.Enabled = false;
            btn14443AAuth1.Enabled = false;
            btn14443ALoadKey.Enabled = false;
            btn14443AAuthKey.Enabled = false;
            btn14443AHalt2.Enabled = false;
            btn14443ASelect.Enabled = false;
            btn14443AULAnticoll.Enabled = false;
            btn14443AAnticoll.Enabled = false;
            btn14443ARequest.Enabled = false;
            btn14443ARWWrite.Enabled = false;
            btn14443ARWRead.Enabled = false;
            btn14443ADecrement.Enabled = false;
            btn14443AIncrement.Enabled = false;
            btn14443AInitValue.Enabled = false;
            btn14443AReadValue.Enabled = false;
            btn14443BReqAll.Enabled = false;
            btn14443BReqIdelAFI.Enabled = false;
            btn14443BReqAllAFI.Enabled = false;
            btn14443BReqIdel.Enabled = false;
            btn14443BAnticollIdelAFI.Enabled = false;
            btn14443BAnticollAllAFI.Enabled = false;
            btn14443BAnticollIdel.Enabled = false;
            btn14443BAnticollAll.Enabled = false;
            btn14443BSelect.Enabled = false;
            btn14443BSendTrspCmd.Enabled = false;
            btnChangeToISO14443B.Enabled = false;
            btn14443BCloseRF.Enabled = false;
            btn14443BOpenRF.Enabled = false;
            btn14443BHalt.Enabled = false;
        }

        private void EnableButton()
        {

            btnGetReaderInfo.Enabled = true;
            //btnContinueInventoryScanWithAFI.Enabled = true;
            //btnContinueInventoryScanNoAFI.Enabled = true;
            //btnNewInventoryScanWithAFI.Enabled = true;
            //btnNewInventoryScanNoAFI.Enabled = true;
            //btnInventoryWithAFI.Enabled = true;
            //btnInventoryNoAFI.Enabled = true;           
            btnCloseRF.Enabled = true;
            btnOpenRF.Enabled = true;

            btnWriteAddress.Enabled = true;
            btnWriteInventoryScanTime.Enabled = true;
            btnSetLED.Enabled = true;
            btnSetBuzzer.Enabled = true;
            btnChangeToISO15693.Enabled = true;
            btnChangeToISO14443A.Enabled = true;
            btn14443ACloseRF.Enabled = true;
            btn14443AOpenRF.Enabled = true;
            //btn14443AHalt.Enabled = true;
            //btn14443AReqAll.Enabled = true;
            //btn14443AReqIdel.Enabled = true;
            //btn14443AWrite.Enabled = true;
            //btn14443ARead.Enabled = true;
            //btn14443AAuth2.Enabled = true;
            //btn14443AAuth1.Enabled = true;
            //btn14443ALoadKey.Enabled = true;
            //btn14443AAuthKey.Enabled = true;
            //btn14443AHalt2.Enabled = true;
            //btn14443ASelect.Enabled = true;
            //btn14443AULAnticoll.Enabled = true;
            //btn14443AAnticoll.Enabled = true;
            //btn14443ARequest.Enabled = true;
            //btn14443ATestMode.Enabled = true;
            //btn14443ARWWrite.Enabled = true;
            //btn14443ARWRead.Enabled = true;
            //btn14443ADecrement.Enabled = true;
            //btn14443AIncrement.Enabled = true;
            //btn14443AInitValue.Enabled = true;
            //btn14443AReadValue.Enabled = true;
            //btn14443BReqAll.Enabled = true;
            //btn14443BReqIdelAFI.Enabled = true;
            //btn14443BReqAllAFI.Enabled = true;
            //btn14443BReqIdel.Enabled = true;
            //btn14443BAnticollIdelAFI.Enabled = true;
            //btn14443BAnticollAllAFI.Enabled = true;
            //btn14443BAnticollIdel.Enabled = true;
            //btn14443BAnticollAll.Enabled = true;
            //btn14443BSelect.Enabled = true;
            //btn14443BSendTrspCmd.Enabled = true;
            //btn14443BTestMode.Enabled = true;
            btnChangeToISO14443B.Enabled = true;
            btn14443BCloseRF.Enabled = true;
            btn14443BOpenRF.Enabled = true;
            //btn14443BHalt.Enabled = true;

        }


        #region AddCmdLog    //״̬,,errorCodeerrorCode
        private void AddCmdLog(string cmdStr, int cmdRet, byte errorCode)
        {
            try
            {
                if (!fAppClose)
                {
                    HFReaderStatusBar.Panels[0].Text = "";
                    if (cmdRet == 0x10)
                    {
                        if (errorCode == 0)
                            HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                             cmdStr + ": " +
                                                             GetReturnCodeDesc(cmdRet);
                        else
                            HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                             cmdStr + ": " +
                                                             GetErrorCodeDesc(errorCode);
                    }
                    else
                    {
                        HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                                cmdStr + ": " +
                                                                GetReturnCodeDesc(cmdRet) + " " +
                                                                GetErrorCodeDesc(errorCode);
                    }
                }
            }
            finally
            {
                ;
            }
        }
        private void AddCmdLog(string cmdStr, int cmdRet)
        {
            try
            {
                if (!fAppClose)
                {
                    HFReaderStatusBar.Panels[0].Text = "";
                    HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                     cmdStr + ": " +
                                                     GetReturnCodeDesc(cmdRet);
                }
            }
            finally
            {
                ;
            }
        }
        #endregion

        #region  16ַ֮໥ת
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        #endregion

        private string GetErrorCodeDesc(byte errorCode)
        {
            switch (errorCode)
            {
                case cmdNotSupport:
                    return "Commands  not supported";
                case cmdNotIdentify:
                    return "Unknown Command";
                case unknownError:
                    return "Unknown error";
                case blockError:
                    return "Appointed  block can't be used or does not exist";
                case blockLockedAndCntLock:
				case blockLockedAndCntWrite:
                    return "Appointed  block is locked";
                case blockCntOperate:
                    return "Appointed  block can't be operated normally";
                case blockCntLock:
                    return "Appointed  block can't be locked normally";
                case cmdNotOperation:
                    return "CMD can't execute at current";
                case 0x33:
                    return "Utralight tag anticollision failed";
                case 0x32:
                    return "MF1 and Utralight tag collision";
                case 0x31:
                    return "Unallow more than one tag in RF field";
                case 0x30:
                    return "Anticollision failed";
                case 0x2E:
                    return "Utralight tag write failed";
                case 0x2D:
                    return "Value operation failed";
                case 0x2C:
                    return "CheckWrite data not match";
                case 0x2B:
                    return "Check write failed";
                case 0x2A:
                    return "Storage key failed";
                case 0x29:
                    return "Read/Write E2PROM failed";
                case 0x28:
                    return "Transfer failed";
                case 0x27:
                    return "Increment/Decrement failed";
                case 0x26:
                    return "Read e-Wallet failed";
                case 0x25:
                    return "e-Wallet initialization failed";
                case 0x24:
                    return "Write failed";
                case 0x23:                
                    return "Read failed";
                case 0x22:
                    return "Authentication failed";
                case 0x21:
                case 0x35:
                    return "Select failed";
                case 0x20:
                    return "No ISO14443A tag";
                case 0x34:
                    return "No ISO14443B tag";
                case 0x36:
                    return "Halt failed";
                case 0x37:
                    return "Transparent command failed";
                case 0x38:
                    return "Anticollision failed";
                default:
                    return "";
            }
        }

        private string GetReturnCodeDesc(int retCode)
        {
            switch (retCode)
            {
                case OK: return "success";
                case lengthError: return "Command operand length error";
                case operationNotSupport: return "Command not supported";
                case RfClosed: return "RF field is inactive";
                case EEPROM: return "E2PROM operation error";
                case timeOut: return "InventoryScanTime overflow,no UID collected";
                case moreUID: return "Not all tag's UID are collected before the InventoryScanTime overflow";
                case ISOError: return "ISO error";
                case noElectronicTag: return "No Tags";
                case operationError: return "Operation error";
                case communicationErr: return "Communication Error";
                case retCRCErr: return "CRC checksummat Error";
                case retDataErr: return "Return data error";
                case communicationBusy: return "Communication busy";
                case cmdNotOperation: return "CMD can't execute at current";
                case dataRangError: return "Operation data range error";
                case invalidHandle: return "Invalid PortHandle";
                case 0x1F: return "Work pattern error";
                default:
                    return "";
            }
        }

        private void btnOpenComPort_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            int port = 1;
            string s;

            try
            {
                this.Cursor = Cursors.WaitCursor;
                if (tbReaderAddr.Text != "")
                {
                    readerAddr = Convert.ToByte(tbReaderAddr.Text, 16);
                }
                else
                {
                    MessageBox.Show("input reader address");
                    return;
                }
                if (cbComPortList.SelectedIndex == 0)           //Auto
                {
                    fCmdRet = StaticClassReaderB.AutoOpenComPort(ref port, ref readerAddr, ref portFrmIndex);
                }
                else
                {
                    port = cbComPortList.SelectedIndex;
                    fCmdRet = StaticClassReaderB.OpenComPort(port, ref readerAddr, ref portFrmIndex);
                }
                if (fCmdRet == 0)
                {
                    cbAlreadyOpenedPortList.Items.Add("COM" + port.ToString());
                    cbAlreadyOpenedPortList.SelectedIndex = cbAlreadyOpenedPortList.Items.Count - 1;
                    EnableButton();
                    fopencomport = portFrmIndex;
                }
                else
                {                   
                    if (cbAlreadyOpenedPortList.Items.Count != 0)
                    {
                        s = cbAlreadyOpenedPortList.SelectedItem.ToString();
                        portFrmIndex = Convert.ToInt16(s.Substring(3, s.Length - 3), 10);
                    }
                    else
                    { 
                        MessageBox.Show("Communication error", "Information");
                    }
                }
                AddCmdLog(btnOpenComPort.Text, fCmdRet);
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }

        }

        private void SystemClear()
        {
            tbSystemInfo.Clear();
            tbSystemInfoData.Clear();
            lbUIDList.Items.Clear();
            cbUIDListforInfo.Items.Clear();
            cb15693BlockNum.Items.Clear();
            cbb15693BlockSize.Items.Clear();
            cbb15693MaxBlockNum.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cbb15693WriteType.Items.Clear();
            tb14443ADataBlock.Clear();
            tb14443AKeyBlock.Clear();
            tb14443BAFI1.Clear();
            tb14443BAFI2.Clear();
            tb14443BAppData1.Clear();
            tb14443BAppData2.Clear();
            tb14443BProtocolInfo1.Clear();
            tb14443BProtocolInfo2.Clear();
        }
        private void btnCloseComPort_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            if (cbAlreadyOpenedPortList.Items.Count == 0 ||
                cbAlreadyOpenedPortList.SelectedItem.ToString() == "")
            {
                MessageBox.Show("Select a port");
                return;
            }

            GetPortFrmIndex();
            fCmdRet = StaticClassReaderB.CloseSpecComPort(portFrmIndex);

            if (fCmdRet == 0)
            {
                cbAlreadyOpenedPortList.Items.Remove(cbAlreadyOpenedPortList.SelectedItem);
            }
            if (cbAlreadyOpenedPortList.Items.Count != 0)
            {
                cbAlreadyOpenedPortList.SelectedIndex = 0;
            }
            else
            {
                portFrmIndex = -1;
                fopencomport = -1;
                ClearReaderInfo();
                SystemClear();
                HFReaderStatusBar.Panels[1].Text = "Port closed";
                DisableButton();
            }
            AddCmdLog(btnCloseComPort.Text, fCmdRet);
        }

        private void ClearReaderInfo()
        {
            tbReaderInfoInventoryScanTime.Text = "";
            tbReaderInfoProtocol.Text = "";
            tbReaderInfoVersion.Text = "";
            tbReadInfoAddr.Text = "";
            tbReaderInfoType.Text = "";
        }

        private void btnGetReaderInfo_Click(object sender, EventArgs e)
        {
            byte[] verInfo = new byte[2];
            byte[] trType = new byte[2];
            byte readerType = 0;
            byte inventoryScanTime = 0;
            int fCmdRet = 0x30;

            ClearReaderInfo();
            fCmdRet = StaticClassReaderB.GetReaderInformation(ref readerAddr, verInfo,
                                                    ref readerType, trType,
                                                    ref inventoryScanTime, portFrmIndex);

            if (fCmdRet == 0)
            {
                tbReadInfoAddr.Text = Convert.ToString(readerAddr, 16).PadLeft(2, '0').ToUpper();
                tbReaderInfoVersion.Text = Convert.ToString(verInfo[0], 10).PadLeft(2, '0') + "." +
                                           Convert.ToString(verInfo[1], 10).PadRight(2, '0');
                if (readerType==0x45)
                    tbReaderInfoType.Text = "HFReader";
                if (readerType == 0x66)
                    tbReaderInfoType.Text = "HFReader";
                if ((trType[1] & 0x08) == 0x08)
                { tbReaderInfoProtocol.Text = "ISO15693, ISO14443A, ISO14443B"; }
                tbReaderInfoInventoryScanTime.Text = inventoryScanTime.ToString().ToUpper();
            }
            AddCmdLog(btnGetReaderInfo.Text, fCmdRet);
        }

        private void GetPortFrmIndex()
        {
            string s;

            s = cbAlreadyOpenedPortList.SelectedItem.ToString();
            portFrmIndex = Convert.ToInt16(s.Substring(3, s.Length - 3), 10);
        }

        //ɾһitemʱ¼
        private void cbAlreadyOpenedPortList_SelectedIndexChanged(object sender, EventArgs e)
        {
            string s;

            s = cbAlreadyOpenedPortList.SelectedItem.ToString();
            portFrmIndex = Convert.ToInt16(s.Substring(3, s.Length - 3), 10);
            readerAddr = 0xff;
            btnGetReaderInfo_Click(null, null);
            HFReaderStatusBar.Panels[1].Text = "COM" + portFrmIndex.ToString();
        }

        private void btnOpenRF_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            fCmdRet = StaticClassReaderB.OpenRf(ref readerAddr, portFrmIndex);
            AddCmdLog(btnOpenRF.Text, fCmdRet);
        }

        private void btnCloseRF_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            fCmdRet = StaticClassReaderB.CloseRf(ref readerAddr, portFrmIndex);
            AddCmdLog(btnCloseRF.Text, fCmdRet);
        }

        private void btnWriteAddress_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte newReaderAddr = 0;

            if (tbReaderAddrToWrite.Text == "")
            {
                MessageBox.Show("Input a reader address");
                return;
            }
            newReaderAddr = Convert.ToByte(tbReaderAddrToWrite.Text, 16);
            fCmdRet = StaticClassReaderB.WriteComAdr(ref readerAddr, ref newReaderAddr, portFrmIndex);
            if (fCmdRet == 0)
            {
                readerAddr = newReaderAddr;
                btnGetReaderInfo_Click(null, null);
            }
            AddCmdLog("Write Reader Address", fCmdRet);
        }

        private void btnSetLED_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte OnTime, OffTime, Repeat;

            OnTime = (byte)cbLEDOnTime.SelectedIndex;
            OffTime = (byte)cbLEDOffTime.SelectedIndex;
            Repeat = (byte)cbLEDRepeatTimes.SelectedIndex;

            fCmdRet = StaticClassReaderB.SetLED(ref readerAddr, OnTime, OffTime, Repeat, portFrmIndex);
            AddCmdLog("Set LED", fCmdRet);
        }

        private void btnSetBuzzer_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte OnTime, OffTime, Repeat;

            OnTime = (byte)cbBuzzerOnTime.SelectedIndex;
            OffTime = (byte)cbBuzzerOffTime.SelectedIndex;
            Repeat = (byte)cbBuzzerRepeatTimes.SelectedIndex;

            fCmdRet = StaticClassReaderB.SetBeep(ref readerAddr, OnTime, OffTime, Repeat, portFrmIndex);
            AddCmdLog("Set Buzzer", fCmdRet);
        }

        private void btnWriteInventoryScanTime_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte inventoryScanTime = 30;

            inventoryScanTime = (byte)(cbInventoryScanTimeToWrite.SelectedIndex + 3);
            fCmdRet = StaticClassReaderB.WriteInventoryScanTime(ref readerAddr, ref inventoryScanTime, portFrmIndex);
            if (fCmdRet == 0)
            {
                btnGetReaderInfo_Click(null, null);
            }
            AddCmdLog("Write inventoryscantime", fCmdRet);
        }

        private void btnChangeToISO15693_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            fCmdRet = StaticClassReaderB.ChangeTo15693(ref readerAddr, portFrmIndex);

            if (fCmdRet == 0)
            {
                btnContinueInventoryScanWithAFI.Enabled = true;
                btnContinueInventoryScanNoAFI.Enabled = true;
                btnNewInventoryScanWithAFI.Enabled = true;
                btnNewInventoryScanNoAFI.Enabled = true;
                btnInventoryWithAFI.Enabled = true;
                btnInventoryNoAFI.Enabled = true;
                ISO15693MODE = true;
                ISO14443BMODE = false;
                ISO14443AMODE = false;
            }
            else
                ISO15693MODE = false;
            AddCmdLog(btnChangeToISO15693.Text, fCmdRet);
        }

        private void btnChangeToISO14443A_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            fCmdRet = StaticClassReaderB.ChangeTo14443A(ref readerAddr, portFrmIndex);

            if (fCmdRet == 0)
            {
                btn14443AAuth2.Enabled = true;
                btn14443AAuth1.Enabled = true;
                btn14443ALoadKey.Enabled = true;
                btn14443AAuthKey.Enabled = true;
                btn14443AHalt2.Enabled = true;
                btn14443ASelect.Enabled = true;
                btn14443AULAnticoll.Enabled = true;
                btn14443AAnticoll.Enabled = true;
                btn14443ARequest.Enabled = true;
                btn14443ARWWrite.Enabled = true;
                btn14443ARWRead.Enabled = true;
                btn14443ADecrement.Enabled = true;
                btn14443AIncrement.Enabled = true;
                btn14443AInitValue.Enabled = true;
                btn14443AReadValue.Enabled = true;
                ISO15693MODE = false;
                ISO14443BMODE = false;
                ISO14443AMODE = true;
            }
            else
                ISO14443AMODE = false;
            AddCmdLog(btnChangeToISO14443A.Text, fCmdRet);
        }

        private void btnChangeToISO14443B_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;

            fCmdRet = StaticClassReaderB.ChangeTo14443B(ref readerAddr, portFrmIndex);
            if (fCmdRet == 0)
            {
                btn14443BReqAll.Enabled = true;
                btn14443BReqIdelAFI.Enabled = true;
                btn14443BReqAllAFI.Enabled = true;
                btn14443BReqIdel.Enabled = true;
                btn14443BAnticollIdelAFI.Enabled = true;
                btn14443BAnticollAllAFI.Enabled = true;
                btn14443BAnticollIdel.Enabled = true;
                btn14443BAnticollAll.Enabled = true;
                btn14443BSelect.Enabled = true;
                btn14443BSendTrspCmd.Enabled = true;
                btn14443BHalt.Enabled = true;
                ISO15693MODE = false;
                ISO14443BMODE = true;
                ISO14443AMODE = false;
            }
            else
                ISO14443BMODE = false;
            AddCmdLog(btnChangeToISO14443B.Text, fCmdRet);
        }

        private void btnInventoryNoAFI_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte state = 0;
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[9];
            byte cardNumber = 0;
            string strDSFIDAndUID = "";

            cbUIDListforInfo.Items.Clear();
            lbUIDList.Items.Clear();
            labelCardNum.Text = "0";
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbb15693WriteType.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            cb15693BlockNum.Items.Clear();

            if (sender == btnInventoryWithAFI)
            {
                if (tbAFI.Text == "")
                {
                    MessageBox.Show("Input AFI");
                    return;
                }
                AFI = Convert.ToByte(tbAFI.Text, 16);
                state = 1;
            }

            fCmdRet = StaticClassReaderB.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portFrmIndex);
            if (fCmdRet == 0)
            {
                strDSFIDAndUID = ByteArrayToHexString(DSFIDAndUID).Replace(" ", "");
                cbUIDListforInfo.Items.Add(strDSFIDAndUID.Substring(2, 16));
                cbUIDListforInfo.SelectedIndex = 0;
                lbUIDList.Items.Add(strDSFIDAndUID.Substring(2, 16));
                labelCardNum.Text = cardNumber.ToString();
            }
            AddCmdLog(((Button)sender).Text, fCmdRet);
        }

        private void btnNewInventoryScanNoAFI_Click(object sender, EventArgs e)
        {
            int i, fCmdRet = 0x30;
            byte state = 6;             //ĬϲAFIInventoryScan
            byte AFI = 0;
            byte[] DSFIDAndUID = new byte[153];
            byte cardNumber = 0;
            ListViewItem aListItem = new ListViewItem();
            string s = "", FirmName = "", strDSFIDAndUID = "";
            byte BlockSize = 0;
            byte BlockNum = 0;
            string TagType = "";

            cbUIDListforInfo.Items.Clear();
            lbUIDList.Items.Clear();
            labelCardNum.Text = "0";
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbb15693WriteType.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            cb15693BlockNum.Items.Clear();
            cbb15693BlockSize.Items.Clear();
            cbb15693MaxBlockNum.Items.Clear();

            if (sender == btnContinueInventoryScanNoAFI)
            {
                state = 2;
            }
            else if (sender == btnNewInventoryScanWithAFI)
            {
                if (tbAFI.Text == "")
                {
                    MessageBox.Show("Input AFI");
                    return;
                }
                AFI = Convert.ToByte(tbAFI.Text, 16);
                state = 7;
            }
            else if (sender == btnContinueInventoryScanWithAFI)
            {
                if (tbAFI.Text == "")
                {
                    MessageBox.Show("Input AFI");
                    return;
                }
                AFI = Convert.ToByte(tbAFI.Text, 16);
                state = 3;
            }
            fCmdRet = StaticClassReaderB.Inventory(ref readerAddr, ref state, ref AFI, DSFIDAndUID, ref cardNumber, portFrmIndex);

            if ((fCmdRet == 0x00) || (fCmdRet == 0x0B) || (fCmdRet == 0x0E))
            {
                Array.Resize(ref DSFIDAndUID, cardNumber * 9);
                strDSFIDAndUID = ByteArrayToHexString(DSFIDAndUID).Replace(" ", "");
                if (fIsTestMode)
                {
                    DeleteRepeatUID(strDSFIDAndUID, ref DSFIDAndUIDList);
                    totalCardNumber = (byte)(DSFIDAndUIDList.Length / 18);
                    if ((fCmdRet == 0x00) || (fCmdRet == 0x0E))
                    {
                        while (lvTestMode.Items.Count < totalCardNumber)     //Ϊ˲˸
                        {
                            aListItem = lvTestMode.Items.Add((lvTestMode.Items.Count + 1).ToString());
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                        }
                        while (lvTestMode.Items.Count > totalCardNumber)
                        { lvTestMode.Items.Remove(lvTestMode.Items[lvTestMode.Items.Count - 1]); }
                        for (i = 0; i < totalCardNumber; i++)
                        {

                            aListItem = lvTestMode.Items[i];
                            GetTagInfo(Convert.ToByte(DSFIDAndUIDList.Substring(18 * i + 14, 2), 16),
                                       Convert.ToByte(DSFIDAndUIDList.Substring(18 * i + 16, 2), 16),
                                       ref FirmName, ref BlockSize, ref BlockNum, ref TagType);
                            ChangeSubItem(aListItem, 1, FirmName);
                            s = DSFIDAndUIDList.Substring(18 * i + 2, 16);
                            ChangeSubItem(aListItem, 2, s);
                            s = DSFIDAndUIDList.Substring(18 * i, 2);
                            ChangeSubItem(aListItem, 3, s);
                        }
                    }
                    if (fCmdRet == 0x0B)
                    {
                        btnNewInventoryScanNoAFI_Click(btnContinueInventoryScanNoAFI, null);
                    }
                }
                else
                {
                    if ((fCmdRet == 0x00) || (fCmdRet == 0x0B))
                    {
                        for (i = 0; i < cardNumber; i++)
                        {
                            s = strDSFIDAndUID.Substring(18 * i, 18);
                            cbUIDListforInfo.Items.Add(s.Substring(2, 16));
                            lbUIDList.Items.Add(s);
                            labelCardNum.Text = cardNumber.ToString();
                        }
                        if (cardNumber > 0)
                        {
                            cbUIDListforInfo.SelectedIndex = 0;
                        }
                    }
                }
            }
            if ((fIsTestMode) && ((fCmdRet == 0) || (fCmdRet == 0x0B)))
                AddCmdLog(((Button)sender).Text, 0); //ģʽֻҪInventoryķֵ0,0x0B,0x0EΪִгɹ
            else
                AddCmdLog(((Button)sender).Text, fCmdRet);
        }

        private void ChangeSubItem(ListViewItem ListItem, int subItemIndex, string ItemText)
        {
            if (ListItem.SubItems[subItemIndex].Text != ItemText)
            {
                ListItem.SubItems[subItemIndex].Text = ItemText;
            }
        }

        private void DeleteRepeatUID(string tempUIDString, ref string uniqueUIDString)
        {
            int i;
            string s;
            for (i = 0; i < tempUIDString.Length / 18; i++)
            {
                s = tempUIDString.Substring(18 * i, 18);
                if (uniqueUIDString.IndexOf(s) < 0)
                    uniqueUIDString = uniqueUIDString + s;
            }
        }

        private void GetTagInfo(byte FirmCode, byte OtherCode, ref string FirmName, ref byte BlockSize, ref byte BlockNum, ref string TagType)
        {
            switch (FirmCode)
            {
                case 0x02:
                    BlockSize = 4;
                    BlockNum = 16;
                    TagType = "B";
                    FirmName = "STMicroelectronics";
                    break;
                case 0x04:
                    BlockSize = 4;
                    BlockNum = 28;
                    TagType = "B";
                    FirmName = "Philips Semiconductors";
                    break;
                case 0x05:
                    BlockSize = 4;
                    BlockNum = 58;
                    if (OtherCode == 0xE0)
                        BlockNum = 250;
                    else if (OtherCode == 0x60)
                        BlockNum = 58;
                    TagType = "B";
                    FirmName = "Infineon";
                    break;
                case 0x07:
                    BlockSize = 4;
                    BlockNum = 64;
                    TagType = "A";
                    FirmName = "Texas Instruments";
                    break;
                case 0x08:
                    BlockSize = 8;
                    BlockNum = 250;
                    TagType = "A/B";
                    FirmName = "Fujitsu";
                    break;
                case 0x16:
                    BlockSize = 4;
                    BlockNum = 14;
                    TagType = "A";
                    FirmName = "EM Microelectronic";
                    break;
                default:
                    FirmName = "";
                    break;
            }
        }

        #region   ȡĳЩstateֵ
        private byte GetState()
        {
            return (byte)(rbAddressMode.Checked ? 0 : 1);
        }
        private byte GetState(string writeType)
        {
            if (writeType.IndexOf("A") >= 0)
            {
                return (byte)((rbAddressMode.Checked) ? 0 : 1);
            }
            else
            {
                return (byte)((rbAddressMode.Checked) ? 8 : 9);
            }
        }
        private byte GetState(byte blocSize, string writeType, bool isCheckWriteType)
        {
            if (!isCheckWriteType)
            {
                if (blocSize == 4)
                { return (byte)(rbAddressMode.Checked ? 0 : 1); }
                else
                { return (byte)(rbAddressMode.Checked ? 4 : 5); }
            }
            else
            {
                if (blocSize == 4)
                {
                    if (writeType.IndexOf("A") >= 0)            //Aǩ,ÿ4ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 0 : 1);
                    }
                    else                                        //Bǩ,ÿ4ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 8 : 9);
                    }
                }
                else
                {
                    if (writeType.IndexOf("A") >= 0)            //Aǩ,ÿ8ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 4 : 5);
                    }
                    else                                        //Bǩ,ÿ8ֽ
                    {
                        return (byte)((rbAddressMode.Checked) ? 0x0C : 0x0D);
                    }
                }

            }
        }
        #endregion

        private void btnGetSystemInfo_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte state = 0;
            byte informationFlag = 0;
            byte DSFID = 0;
            byte AFI = 0;
            byte ICReference = 0;
            byte[] UIDI = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte[] UIDO = new byte[8];
            byte[] menorySize = new byte[2];
            byte blockSize = 0, blockNum = 0;
            string tagWriteType = "";
            string FirmName = "";
            int i;

            btnReadSingleBlock.Enabled = false;
            btnReadMultiBlock.Enabled = false;
            btnWriteSingleBlock.Enabled = false;
            btnLcokBlock.Enabled = false;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            state = GetState();

            if (rbAddressMode.Checked)
                UIDI = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            fCmdRet = StaticClassReaderB.GetSystemInformation(ref readerAddr, ref state, UIDI, ref informationFlag, UIDO,
                                                    ref DSFID, ref AFI, menorySize,
                                                    ref ICReference, ref errorCode, portFrmIndex);
            tbSystemInfoData.Text = "";
            tbSystemInfo.Text = "";
            cbb15693WriteType.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cb15693BlockNum.Items.Clear();
            cbb15693MaxBlockNum.Items.Clear();
            cbb15693BlockSize.Items.Clear();
            tbDataReaded.Text = "";
            tbDataToWrite.Text = "";

            if (fCmdRet == 0)
            {
                tbSystemInfoData.Text = ByteArrayToHexString(UIDO).Replace(" ", "");
                tbSystemInfo.Text = "UID0: " + ByteArrayToHexString(UIDO).Replace(" ", "");
                if ((informationFlag & 0x01) == 0x01)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "DSFID: " + Convert.ToString(DSFID, 16).PadLeft(2, '0').ToUpper();
                }
                if ((informationFlag & 0x02) == 0x02)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "AFI: " + Convert.ToString(AFI, 16).PadLeft(2, '0').ToUpper();
                }
                if ((informationFlag & 0x04) == 0x04)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + ByteArrayToHexString(menorySize).Replace(" ", "");
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "MemorySize: " + ByteArrayToHexString(menorySize).Replace(" ", "");
                }
                if ((informationFlag & 0x08) == 0x08)
                {
                    tbSystemInfoData.Text = tbSystemInfoData.Text + " " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                    tbSystemInfo.Text = tbSystemInfo.Text + " " + "ICReference: " + Convert.ToString(ICReference, 16).PadLeft(2, '0').ToUpper();
                }

                GetTagInfo(UIDO[6], UIDO[7], ref FirmName, ref blockSize, ref blockNum, ref tagWriteType);

                cbb15693WriteType.Items.Add("A");
                cbb15693WriteType.Items.Add("B");
                if (tagWriteType.IndexOf("B") != -1)
                { cbb15693WriteType.SelectedIndex = 1; }
                else
                { cbb15693WriteType.SelectedIndex = 0; }

                cbb15693BlockSize.Items.Add("4");
                cbb15693BlockSize.Items.Add("8");
                if (blockSize == 8)
                { cbb15693BlockSize.SelectedIndex = 1; }
                else
                { cbb15693BlockSize.SelectedIndex = 0; }

                for (i = 0; i < 256; i++)
                {
                    cbb15693MaxBlockNum.Items.Add(i.ToString());
                }
                cbb15693MaxBlockNum.SelectedIndex = blockNum - 1;

                HFReaderStatusBar.Panels[2].Text = FirmName + "," + "Type " + tagWriteType + "," + blockSize.ToString() +
                                            "bytes/Block," + blockNum.ToString() + "Blocks";
            }
            AddCmdLog(btnGetSystemInfo.Text, fCmdRet, errorCode);
        }

        private void cbb15693MaxBlockNum_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i;
            cb15693BlockNum.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            for (i = 0; i < cbb15693MaxBlockNum.SelectedIndex + 1; i++)
            {
                cb15693BlockNum.Items.Add(i.ToString());
                cbb15693StartBlokNum.Items.Add(i.ToString());
                cbb15693OverBlokNum.Items.Add(i.ToString());
            }

            cbb15693StartBlokNum.SelectedIndex = 0;
            cbb15693OverBlokNum.SelectedIndex = 0;
        }

        private void cb15693BlockNum_SelectionChangeCommitted(object sender, EventArgs e)
        {
            btnReadSingleBlock.Enabled = true;
            btnReadMultiBlock.Enabled = true;
            btnWriteSingleBlock.Enabled = true;
            btnLcokBlock.Enabled = true;
        }

        private void btnReadSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte blockSecStatus = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            tbDataReaded.Text = "";

            blockNum = (byte)cb15693BlockNum.SelectedIndex;
            state = GetState((byte)(cbb15693BlockSize.SelectedIndex * 4 + 4), cbb15693WriteType.SelectedText, false);

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            byte[] data = new byte[cbb15693BlockSize.SelectedIndex * 4 + 4];
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());

            fCmdRet = StaticClassReaderB.ReadSingleBlock(ref readerAddr, ref state, UID, blockNum, ref blockSecStatus, data, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
                tbDataReaded.Text = blockSecStatus.ToString("x2") + " " + ByteArrayToHexString(data).Replace(" ", "");
            AddCmdLog(btnReadSingleBlock.Text, fCmdRet, errorCode);
        }

        private void btnWriteSingleBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte blockNum = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };

            if (tbDataToWrite.Text.Length != (cbb15693BlockSize.SelectedIndex * 4 + 4) * 2)
            {
                MessageBox.Show("please input correct data");
                return;
            }
            if ((rbAddressMode.Checked) &&
               ((cbUIDListforInfo.Items.Count == 0) ||
                (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            byte[] data = new byte[cbb15693BlockSize.SelectedIndex * 4 + 4];
            data = HexStringToByteArray(tbDataToWrite.Text);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            blockNum = (byte)cb15693BlockNum.SelectedIndex;
            state = GetState((byte)(cbb15693BlockSize.SelectedIndex * 4 + 4), cbb15693WriteType.SelectedItem.ToString(), true);

            fCmdRet = StaticClassReaderB.WriteSingleBlock(ref readerAddr, ref state, UID, blockNum, data, ref errorCode, portFrmIndex);

            AddCmdLog(btnWriteSingleBlock.Text, fCmdRet, errorCode);
        }

        private void btnReadMultiBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte errorCode = 0;
            int fCmdRet = 0x30;
            byte startBlockNum = 0;
            byte blockCount = 0;
            byte blockSize = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            int i;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }

            startBlockNum = (byte)cbb15693StartBlokNum.SelectedIndex;
            if (cbb15693OverBlokNum.SelectedIndex < startBlockNum)
            {
                MessageBox.Show("Block number error");
                return;
            }
            blockCount = (byte)(cbb15693OverBlokNum.SelectedIndex - startBlockNum + 1);
            blockSize = (byte)(cbb15693BlockSize.SelectedIndex * 4 + 4);
            if (cbb15693BlockSize.SelectedIndex == 0)            //BlockSizeΪ4ʱ,һܶȡ28
            {
                if (blockCount > 12)
                {
                    MessageBox.Show("block count can't over 12");
                    return;
                }
            }
            else                                            //BlockSizeΪ8ʱ,һܶȡ15
            {
                if (blockCount > 6)
                {
                    MessageBox.Show("block count can't over 6");
                    return;
                }
            }

            byte[] data = new byte[blockSize * blockCount];
            byte[] blockSecStatus = new byte[blockCount];
            state = GetState(blockSize, cbb15693WriteType.SelectedItem.ToString(), false);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());

            fCmdRet = StaticClassReaderB.ReadMultipleBlock(ref readerAddr, ref state, UID, startBlockNum, blockCount,
                                                       blockSecStatus, data, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                frmMultipleBlockDataList frmdata = new frmMultipleBlockDataList();
                frmdata.Text = cbUIDListforInfo.SelectedItem.ToString()
                               + "  block" + startBlockNum.ToString()
                               + " - block" + cbb15693OverBlokNum.SelectedIndex.ToString();
                string temp = ByteArrayToHexString(data).Replace(" ", "");
                for (i = startBlockNum; i < cbb15693OverBlokNum.SelectedIndex + 1; i++)
                {
                    frmdata.ListView1.Items.Add(i.ToString());
                    frmdata.ListView1.Items[i - startBlockNum].SubItems.Add(Convert.ToString(blockSecStatus[i - startBlockNum], 16).PadLeft(2, '0')
                                                                            + " "
                                                                            + temp.Substring((i - startBlockNum) * blockSize * 2, blockSize * 2));
                }
                frmdata.Show();
            }
            AddCmdLog(btnReadMultiBlock.Text, fCmdRet, errorCode);
        }

        private void cbb15693BlockSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            tbDataToWrite.MaxLength = (cbb15693BlockSize.SelectedIndex * 4 + 4) * 2;
        }

        private void btnLcokBlock_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte blockNum = 0;
            int fCmdRet = 0x30;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (MessageBox.Show(this, "Lock this block ?", "Lock", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;

            UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState(cbb15693WriteType.SelectedText);
            blockNum = (byte)cb15693BlockNum.SelectedIndex;
            fCmdRet = StaticClassReaderB.LockBlock(ref readerAddr, ref state, UID, blockNum, ref errorCode, portFrmIndex);

            AddCmdLog(btnLcokBlock.Text, fCmdRet, errorCode);
        }

        private void btnWriteAFI_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte AFI = 0;
            int fCmdRet = 0x30;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (tbAFI.Text == "")
            {
                MessageBox.Show("Input AFI");
                return;
            }
            AFI = Convert.ToByte(tbAFI.Text, 16);
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState(cbb15693WriteType.SelectedText);
            fCmdRet = StaticClassReaderB.WriteAFI(ref readerAddr, ref state, UID, AFI, ref errorCode, portFrmIndex);

            AddCmdLog("Write AFI", fCmdRet, errorCode);
        }

        private void btnLockAFI_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            int fCmdRet = 0x30;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (MessageBox.Show(this, "Lock AFI ?", "Lock", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;

            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState(cbb15693WriteType.SelectedText);
            fCmdRet = StaticClassReaderB.LockAFI(ref readerAddr, ref state, UID, ref errorCode, portFrmIndex);

            AddCmdLog("Lock AFI", fCmdRet, errorCode);
        }

        private void btnWriteDSFID_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            byte DSFID = 0;
            int fCmdRet = 0x30;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (tbDSFID.Text == "")
            {
                MessageBox.Show("Input DSFID");
                return;
            }
            DSFID = Convert.ToByte(tbDSFID.Text, 16);

            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState(cbb15693WriteType.SelectedText);
            fCmdRet = StaticClassReaderB.WriteDSFID(ref readerAddr, ref state, UID, DSFID, ref errorCode, portFrmIndex);

            AddCmdLog("Write DSFID", fCmdRet, errorCode);
        }

        private void btnLockDSFID_Click(object sender, EventArgs e)
        {
            byte state = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };
            byte errorCode = 0;
            int fCmdRet = 0x30;

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (MessageBox.Show(this, "Lock DSFID ?", "Lock", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState(cbb15693WriteType.SelectedText);
            fCmdRet = StaticClassReaderB.LockDSFID(ref readerAddr, ref state, UID, ref errorCode, portFrmIndex);

            AddCmdLog("Lock DSFID", fCmdRet, errorCode);
        }

        private void btnStayQuite_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte[] uid = new byte[8];

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            uid = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            fCmdRet = StaticClassReaderB.StayQuiet(ref readerAddr, uid, ref errorCode, portFrmIndex);
            AddCmdLog(btnStayQuite.Text, fCmdRet, errorCode);
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte[] uid = new byte[8];

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            uid = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());

            fCmdRet = StaticClassReaderB.Select(ref readerAddr, uid, ref errorCode, portFrmIndex);
            AddCmdLog(btnSelect.Text, fCmdRet, errorCode);
        }

        private void btnResetToReady_Click(object sender, EventArgs e)
        {

            int fCmdRet = 0x30;
            byte state;
            byte errorCode = 0;
            byte[] UID = { 0, 0, 0, 0, 0, 0, 0, 0 };

            if ((rbAddressMode.Checked) &&
                ((cbUIDListforInfo.Items.Count == 0) ||
                 (cbUIDListforInfo.SelectedItem == null)))
            {
                MessageBox.Show("Select a UID");
                return;
            }
            if (rbAddressMode.Checked)
                UID = HexStringToByteArray(cbUIDListforInfo.SelectedItem.ToString());
            state = GetState();
            fCmdRet = StaticClassReaderB.ResetToReady(ref readerAddr, ref state, UID, ref errorCode, portFrmIndex);

            AddCmdLog(btnResetToReady.Text, fCmdRet, errorCode);
        }

        private void timerTestMode_Tick(object sender, EventArgs e)
        {
            timerTestMode.Enabled = false;
            DSFIDAndUIDList = "";
            totalCardNumber = 0;
            btnNewInventoryScanNoAFI_Click(btnNewInventoryScanNoAFI, null);
            if ((fIsTestMode) && (!fAppClose))
                timerTestMode.Enabled = true;
        }

        private void btnStartTestMode_Click(object sender, EventArgs e)
        {
            btnStartTestMode.Enabled = false;
            btnStopTestMode.Enabled = true;
            fIsTestMode = true;
            timerTestMode.Enabled = true;
        }

        private void btnStopTestMode_Click(object sender, EventArgs e)
        {
            timerTestMode.Enabled = false;
            fIsTestMode = false;
            btnStartTestMode.Enabled = true;
            btnStopTestMode.Enabled = false;
        }

        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)
        {
            fIsTestMode = false;
            labelCardNum.Text = "0";
            cb15693BlockNum.Items.Clear();
            cbb15693WriteType.Items.Clear();
            cbb15693MaxBlockNum.Items.Clear();
            cbb15693BlockSize.Items.Clear();
            cbb15693StartBlokNum.Items.Clear();
            cbb15693OverBlokNum.Items.Clear();
            lbUIDList.Items.Clear();
            cbUIDListforInfo.Items.Clear();
            tbSystemInfoData.Clear();
            tbSystemInfo.Clear();
            btnReadSingleBlock.Enabled = false;
            btnWriteSingleBlock.Enabled = false;
            btnLcokBlock.Enabled = false;
            btnReadMultiBlock.Enabled = false;
            btnStayQuite.Enabled = false;
            btnSelect.Enabled = false;
            btnResetToReady.Enabled = false;
            tbDataReaded.Clear();
            tbDataToWrite.Clear();
            sBPanelCmdInfo.Text = "";
            sBPanelTagInfo.Text = "";
            if (tabControl1.SelectedTab == tpISO15693TestMode)             //л"ģʽ"ҳ        
            {
                lvTestMode.Items.Clear();
                if (ISO15693MODE == true)
                    btnStartTestMode.Enabled = true;
                else
                    btnStartTestMode.Enabled = false;
                btnStopTestMode.Enabled = false;
            }
            if ((tabControl1.SelectedTab == tpISO14443A) && 
                (cbAlreadyOpenedPortList.Items.Count != 0) &&
                ISO14443AMODE ==false)
            {
                btn14443AAuth2.Enabled = false;
                btn14443AAuth1.Enabled = false;
                btn14443ALoadKey.Enabled = false;
                btn14443AAuthKey.Enabled = false;
                btn14443AHalt2.Enabled = false;
                btn14443ASelect.Enabled = false;
                btn14443AULAnticoll.Enabled = false;
                btn14443AAnticoll.Enabled = false;
                btn14443ARequest.Enabled = false;
                btn14443ARWWrite.Enabled = false;
                btn14443ARWRead.Enabled = false;
                btn14443ADecrement.Enabled = false;
                btn14443AIncrement.Enabled = false;
                btn14443AInitValue.Enabled = false;
                btn14443AReadValue.Enabled = false;
                btnChangeToISO14443A.Enabled = true;
                btn14443ACloseRF.Enabled = true;
                btn14443AOpenRF.Enabled = true;
            }
            if ((tabControl1.SelectedTab == tpISO14443B) && 
                (cbAlreadyOpenedPortList.Items.Count != 0) &&
                ISO14443BMODE ==false)
            {
                btn14443BReqAll.Enabled = false;
                btn14443BReqIdelAFI.Enabled = false;
                btn14443BReqAllAFI.Enabled = false;
                btn14443BReqIdel.Enabled = false;
                btn14443BAnticollIdelAFI.Enabled = false;
                btn14443BAnticollAllAFI.Enabled = false;
                btn14443BAnticollIdel.Enabled = false;
                btn14443BAnticollAll.Enabled = false;
                btn14443BSelect.Enabled = false;
                btn14443BSendTrspCmd.Enabled = false;
                btnChangeToISO14443B.Enabled = true;
                btn14443BCloseRF.Enabled = true;
                btn14443BOpenRF.Enabled = true;
                btn14443BHalt.Enabled = false;
            }
            if ((tabControl1.SelectedTab == tpISO15693) && 
                (cbAlreadyOpenedPortList.Items.Count != 0) &&
                ISO15693MODE == false)
            {
                tbSystemInfo.Clear();
                tbSystemInfoData.Clear();
                btnContinueInventoryScanWithAFI.Enabled = false;
                btnContinueInventoryScanNoAFI.Enabled = false;
                btnNewInventoryScanWithAFI.Enabled = false;
                btnNewInventoryScanNoAFI.Enabled = false;
                btnInventoryWithAFI.Enabled = false;
                btnInventoryNoAFI.Enabled = false;
                btnGetSystemInfo.Enabled = false;
                btnResetToReady.Enabled = false;
                btnSelect.Enabled = false;
                btnGetSystemInfo.Enabled = false;
                btnLockAFI.Enabled = false;
                btnWriteAFI.Enabled = false;
                btnLockDSFID.Enabled = false;
                btnWriteDSFID.Enabled = false;
                btnStayQuite.Enabled = false;
            }
            tb14443ADataBlock.Clear();
            tb14443AKeyBlock.Clear();
            tb14443BPUPI1.Clear();
            tb14443BPUPI2.Clear();
            tb14443BPUPI3.Clear();
            tb14443BProtocolInfo1.Clear();
            tb14443BProtocolInfo2.Clear();
            tb14443BAppData1.Clear();
            tb14443BAppData2.Clear();
            tb14443ACardType.Clear();
            tb14443ACardVolume.Clear();
            tb14443ASNR.Clear();
        }

        private void btn14443AReqIdel_Click(object sender, EventArgs e)
        {
            //int fCmdRet = 0x30;
            //byte[] Data = new byte[2];
            //byte errorCode = 0;
            //byte reserved = 0, size = 0;

            //tb14443ASNR.Text = "";
            //if (sender == btn14443AReqAll)
            //    fCmdRet = StaticClassReaderB.ISO14443ARequest(ref readerAddr, 1, Data, ref errorCode, portFrmIndex);
            //else
            //    fCmdRet = StaticClassReaderB.ISO14443ARequest(ref readerAddr, 0, Data, ref errorCode, portFrmIndex);
            //if (fCmdRet != 0)
            //{
            //    AddCmdLog(((Button)(sender)).Text, fCmdRet, errorCode);
            //    return;
            //}
            //fCmdRet = StaticClassReaderB.ISO14443AAnticoll(ref readerAddr, reserved, SNR, ref errorCode, portFrmIndex);
            //if (fCmdRet != 0)
            //{
            //    AddCmdLog(btn14443AAnticoll.Text, fCmdRet, errorCode);
            //    return;
            //}
            //tb14443ASNR.Text = ByteArrayToHexString(SNR).Replace(" ", "");

            //fCmdRet = StaticClassReaderB.ISO14443ASelect(ref readerAddr, SNR, ref size, ref errorCode, portFrmIndex);
            //if (fCmdRet != 0)
            //{
            //    AddCmdLog(btn14443ASelect.Text, fCmdRet, errorCode);
            //    return;
            //}
            //if (sender == btn14443AReqAll)
            //    AddCmdLog(btn14443AReqAll.Text, 0, 0);
            //else
            //    AddCmdLog(btn14443AReqIdel.Text, 0, 0);
        }

        private void btn14443AHalt2_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;

            fCmdRet = StaticClassReaderB.ISO14443AHalt(ref readerAddr, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443AHalt2.Text, fCmdRet, errorCode);
        }

        private void btn14443ARequest_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte[] Data = new byte[2];
            byte errorCode = 0;

            fCmdRet = StaticClassReaderB.ISO14443ARequest(ref readerAddr, 1, Data, ref errorCode, portFrmIndex);
            tb14443ACardType.Text = "";
            if (fCmdRet == 0)
            {
                tb14443ACardType.Text = ByteArrayToHexString(Data).Replace(" ", "");
                if (tb14443ACardType.Text == "4400")
                {
                    btn14443AAnticoll.Enabled = false;
                    btn14443AAuth1.Enabled = false;
                    btn14443AAuth2.Enabled = false;
                    btn14443AAuthKey.Enabled = false;
                    btn14443ASelect.Enabled = false;
                    btn14443ALoadKey.Enabled = false;
                    button3.Enabled = false;
                    btn14443AChangeKey.Enabled = false;
                    btn14443AReadValue.Enabled = false;
                    btn14443AIncrement.Enabled = false;
                    btn14443ADecrement.Enabled = false;
                    btn14443AInitValue.Enabled = false;
                    cbb14443ARWSector.SelectedIndex = 0;
                    cbb14443ARWSector.Enabled = false;
                    btn14443AULAnticoll.Enabled = true;
                }
                else
                {
                    btn14443AAnticoll.Enabled = true;
                    btn14443AAuth1.Enabled = true;
                    btn14443AAuth2.Enabled = true;
                    btn14443AAuthKey.Enabled = true;
                    btn14443ASelect.Enabled = true;
                    btn14443ALoadKey.Enabled = true;
                    button3.Enabled = true;
                    btn14443AChangeKey.Enabled = true;
                    btn14443AReadValue.Enabled = true;
                    btn14443AIncrement.Enabled = true;
                    btn14443ADecrement.Enabled = true;
                    btn14443AInitValue.Enabled = true;
                    cbb14443ARWSector.Enabled = true;
                    btn14443AULAnticoll.Enabled = false;
                }
            }

            AddCmdLog(btn14443ARequest.Text, fCmdRet, errorCode);
        }

        private void btn14443AAnticoll_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte reserved = 0;
            byte errorCode = 0;


            fCmdRet = StaticClassReaderB.ISO14443AAnticoll(ref readerAddr, reserved, SNR, ref errorCode, portFrmIndex);
            tb14443ASNR.Text = "";

            if (fCmdRet == 0)
                tb14443ASNR.Text = ByteArrayToHexString(SNR).Replace(" ", "");

            AddCmdLog(btn14443AAnticoll.Text, fCmdRet, errorCode);

        }

        private void btn14443AULAnticoll_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte reserved = 0;
            byte errorCode = 0;

            tb14443ASNR.Text = "";
            fCmdRet = StaticClassReaderB.ISO14443AULAnticoll(ref readerAddr, reserved, UL_SNR, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
                tb14443ASNR.Text = ByteArrayToHexString(UL_SNR).Replace(" ", "");

            AddCmdLog(btn14443AULAnticoll.Text, fCmdRet, errorCode);
        }

        private void btn14443ASelect_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;
            byte size = 0;

            fCmdRet = StaticClassReaderB.ISO14443ASelect(ref readerAddr, SNR, ref size, ref errorCode, portFrmIndex);

            tb14443ACardVolume.Text = "";
            if (fCmdRet == 0)
            {
                tb14443ACardVolume.Text = Convert.ToString(size, 16);
            }

            AddCmdLog(btn14443ASelect.Text, fCmdRet, errorCode);
        }

        private void btn14443AAuthKey_Click(object sender, EventArgs e)
        {
            byte errorCode = 0;
            byte keyStyle = 0, accessSector;
            byte[] key = new byte[5];
            string temp;
            int fCmdRet = 0x30;

            if (rb14443ARWKeyA.Checked)
                keyStyle = 0;
            else if (rb14443ARWKeyB.Checked)
                keyStyle = 1;

            accessSector = (byte)cbb14443ARWSector.SelectedIndex;
            temp = tb14443ARWKey.Text;
            if ((temp == "") || (temp.Length != 12))
            {
                MessageBox.Show("Invalid key", "Information");
                return;
            }
            key = HexStringToByteArray(temp);

            fCmdRet = StaticClassReaderB.ISO14443AAuthKey(ref readerAddr, keyStyle, accessSector, key, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443AAuthKey.Text, fCmdRet, errorCode);
        }

        private void btn14443ALoadKey_Click(object sender, EventArgs e)
        {
            byte errorCode = 0;
            byte keyStyle = 0, sector;
            byte[] key = new byte[5];
            string temp;
            int fCmdRet = 0x30;

            if (rb14443ARWKeyA.Checked)
                keyStyle = 0;
            else if (rb14443ARWKeyB.Checked)
                keyStyle = 1;
            sector = (byte)cbb14443AKeyBlockNumber.SelectedIndex;

            temp = tb14443ARWKey.Text;
            if ((temp == "") || (temp.Length != 12))
            {
                MessageBox.Show("Invalid key", "Information");
                return;
            }
            key = HexStringToByteArray(temp);

            fCmdRet = StaticClassReaderB.ISO14443ALoadKey(ref readerAddr, keyStyle, sector, key, ref errorCode, portFrmIndex);
            AddCmdLog(btn14443ALoadKey.Text, fCmdRet, errorCode);
        }

        private void btn14443AAuth1_Click(object sender, EventArgs e)
        {
            byte errorCode = 0;
            byte keyStyle = 0, sector;
            int fCmdRet = 0x30;

            if (rb14443ARWKeyA.Checked)
                keyStyle = 0;
            else if (rb14443ARWKeyB.Checked)
                keyStyle = 1;
            sector = (byte)cbb14443ARWSector.SelectedIndex;

            fCmdRet = StaticClassReaderB.ISO14443AAuthentication(ref readerAddr, keyStyle, sector, ref errorCode, portFrmIndex);
            AddCmdLog(btn14443AAuth1.Text, fCmdRet, errorCode);
        }

        private void btn14443AAuth2_Click(object sender, EventArgs e)
        {
            byte errorCode = 0;
            byte keyStyle = 0, accessSector, authSector;
            int fCmdRet = 0x30;

            if (rb14443ARWKeyA.Checked)
                keyStyle = 0;
            else if (rb14443ARWKeyB.Checked)
                keyStyle = 1;
            accessSector = (byte)cbb14443ARWSector.SelectedIndex;
            authSector = (byte)cbb14443AKeyBlockNumber.SelectedIndex;       //֤
            fCmdRet = StaticClassReaderB.ISO14443AAuthentication2(ref readerAddr, keyStyle, accessSector, authSector, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443AAuth2.Text, fCmdRet, errorCode);
        }

        private void btn14443ARWRead_Click(object sender, EventArgs e)
        {
            byte block, errorCode = 0;
            byte[] data = new byte[16];
            string temp;
            int fCmdRet = 0x30;

            HFReaderStatusBar.Panels[0].Text = "";
            if (cbb14443ARWSector.SelectedIndex >= 32)
                block = (byte)(128 + (cbb14443ARWSector.SelectedIndex - 32) * 16 + cbb14443ARWBlockNumber.SelectedIndex);

            else
                block = (byte)(cbb14443ARWSector.SelectedIndex * 4 + cbb14443ARWBlockNumber.SelectedIndex);

            fCmdRet = StaticClassReaderB.ISO14443ARead(ref readerAddr, block, data, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                temp = ByteArrayToHexString(data).Replace(" ", "");
                if ((cbb14443ARWSector.SelectedIndex < 32 && cbb14443ARWBlockNumber.SelectedIndex == 3) ||
                    (cbb14443ARWSector.SelectedIndex >= 32 && cbb14443ARWBlockNumber.SelectedIndex == 15))
                {
                    tb14443ADataBlock.Text = "";
                    tb14443AKeyBlock.Text = temp;
                }
                else
                {
                    tb14443ADataBlock.Text = temp;
                    tb14443AKeyBlock.Text = "";
                }
            }
            AddCmdLog(btn14443ARWRead.Text, fCmdRet, errorCode);
        }


        private void btn14443AInitValue_Click(object sender, EventArgs e)
        {
            byte errorCode = 0, block;
            string temp;
            byte[] initValue = new byte[4];
            int fCmdRet = 0x30;

            temp = tb14443AOperNumber.Text;
            if ((temp != "") && (temp.Length == 8))
                initValue = HexStringToByteArray(temp);
            else
            {
                MessageBox.Show("Invalid operation number");
                return;
            }
            if (cbbSector2.SelectedIndex > 32)
                block = (byte)(128 + (cbbSector2.SelectedIndex - 32) * 16 + cbb14443ABlockNum.SelectedIndex);
            else
                block = (byte)(cbbSector2.SelectedIndex * 4 + cbb14443ABlockNum.SelectedIndex);
            fCmdRet = StaticClassReaderB.ISO14443AInitValue(ref readerAddr, block, initValue, ref errorCode, portFrmIndex);
            AddCmdLog(btn14443AInitValue.Text, fCmdRet, errorCode);
        }


        private void btn14443AIncrement_Click(object sender, EventArgs e)
        {
            byte errorCode = 0, block;
            string temp;
            byte[] data = new byte[4];
            int fCmdRet = 0x30;

            temp = tb14443AOperNumber.Text;
            if ((temp != "") && (temp.Length == 8))
                data = HexStringToByteArray(temp);
            else
            {
                MessageBox.Show("Invalid operation number");
                return;
            }
            if (cbbSector2.SelectedIndex > 32)
                block = (byte)(128 + (cbbSector2.SelectedIndex - 32) * 16 + cbb14443ABlockNum.SelectedIndex);
            else
                block = (byte)(cbbSector2.SelectedIndex * 4 + cbb14443ABlockNum.SelectedIndex);

            fCmdRet = StaticClassReaderB.ISO14443AIncrement(ref readerAddr, block, data, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443AIncrement.Text, fCmdRet, errorCode);
        }

        private void btn14443ADecrement_Click(object sender, EventArgs e)
        {
            byte errorCode = 0, block;
            string temp;
            byte[] data = new byte[4];
            int fCmdRet = 0x30;

           temp = tb14443AOperNumber.Text;
            if ((temp != "") && (temp.Length == 8))
                data = HexStringToByteArray(temp);
            else
            {
                MessageBox.Show("Invalid operation number");
                return;
            }
            if (cbbSector2.SelectedIndex > 32)
                block = (byte)(128 + (cbbSector2.SelectedIndex - 32) * 16 + cbb14443ABlockNum.SelectedIndex);
            else
                block = (byte)(cbbSector2.SelectedIndex * 4 + cbb14443ABlockNum.SelectedIndex);

            fCmdRet = StaticClassReaderB.ISO14443ADecrement(ref readerAddr, block, data, ref errorCode, portFrmIndex);
            AddCmdLog(btn14443ADecrement.Text, fCmdRet, errorCode);
        }

        private void btn14443AReadValue_Click(object sender, EventArgs e)
        {
            byte errorCode = 0,block;
            byte[] key = new byte[6];
            byte[] Value = new byte[4];
            int fCmdRet = 0x30;

            if (cbbSector2.SelectedIndex > 32)
                block = (byte)(128 + (cbbSector2.SelectedIndex - 32) * 16 + cbb14443ABlockNum.SelectedIndex);
            else
                block = (byte)(cbbSector2.SelectedIndex * 4 + cbb14443ABlockNum.SelectedIndex);
            fCmdRet = StaticClassReaderB.ISO14443AReadValue(ref readerAddr, block, Value, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                tb14443AOperNumber.Text = ByteArrayToHexString(Value).Replace(" ", "");
            }
            AddCmdLog(btn14443AReadValue.Text, fCmdRet, errorCode);
        }

        private void MainFrmHFReader_FormClosing(object sender, FormClosingEventArgs e)
        {
            fAppClose = true;
            fIsTestMode = false;
            timerTestMode.Enabled = false;
        }

        private void btn14443BReqAll_Click(object sender, EventArgs e)
        {
            byte Mode = 0, AFI = 0, errorCode = 0;
            byte[] AppData = new byte[4];
            byte[] ProtocolInfo = new byte[3];
            int fCmdRet = 0x30;

            tb14443BPUPI1.Clear();
            tb14443BAppData1.Clear();
            tb14443BProtocolInfo1.Clear();
            if (sender == btn14443BReqAll)
            {
                Mode = 1;
                AFI = 0;
            }
            else if (sender == btn14443BReqIdel)
            {
                Mode = 0;
                AFI = 0;
            }
            else if (sender == btn14443BReqIdelAFI)
            {
                Mode = 0;
                if (tb14443BAFI1.Text != "")
                    AFI = Convert.ToByte(tb14443BAFI1.Text, 16);
                else
                {
                    MessageBox.Show("Invalid AFI");
                    return;
                }
            }
            else if (sender == btn14443BReqAllAFI)
            {
                Mode = 1;
                if (tb14443BAFI1.Text != "")
                    AFI = Convert.ToByte(tb14443BAFI1.Text, 16);
                else
                {
                    MessageBox.Show("Invalid AFI");
                    return;
                }
            }
            fCmdRet = StaticClassReaderB.ISO14443BRequest(ref readerAddr, Mode, AFI, PUPI, AppData, ProtocolInfo, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                tb14443BPUPI1.Text = ByteArrayToHexString(PUPI).Replace(" ", "");
                tb14443BAppData1.Text = ByteArrayToHexString(AppData).Replace(" ", "");
                tb14443BProtocolInfo1.Text = ByteArrayToHexString(ProtocolInfo).Replace(" ", "");
            }
            AddCmdLog(((Button)(sender)).Text, fCmdRet, errorCode);
        }

        private void btn14443BAnticollAll_Click(object sender, EventArgs e)
        {
            byte Mode = 0, AFI = 0, errorCode = 0;
            byte[] AppData = new byte[4];
            byte[] ProtocolInfo = new byte[3];
            int fCmdRet = 0x30;

            tb14443BPUPI2.Clear();
            tb14443BAppData2.Clear();
            tb14443BProtocolInfo2.Clear();

            if (sender == btn14443BAnticollAll)
            {
                Mode = 1;
                AFI = 0;
            }
            else if (sender == btn14443BAnticollIdel)
            {
                Mode = 0;
                AFI = 0;
            }
            else if (sender == btn14443BAnticollIdelAFI)
            {
                Mode = 0;
                if (tb14443BAFI2.Text != "")
                    AFI = Convert.ToByte(tb14443BAFI2.Text, 16);
                else
                {
                    MessageBox.Show("Invalid AFI");
                    return;
                }
            }
            else if (sender == btn14443BAnticollAllAFI)
            {
                Mode = 1;
                if (tb14443BAFI2.Text != "")
                    AFI = Convert.ToByte(tb14443BAFI2.Text, 16);
                else
                {
                    MessageBox.Show("Invalid AFI");
                    return;
                }
            }
            {
                btn14443BAnticollIdelAFI.Enabled = false; btn14443BReqIdelAFI.Enabled = false;
                btn14443BAnticollIdel.Enabled = false; btn14443BSelect.Enabled = false;
                btn14443BCloseRF.Enabled = false; btn14443BSendTrspCmd.Enabled = false;
                btn14443BHalt.Enabled = false;
                btn14443BOpenRF.Enabled = false; btn14443BAnticollAll.Enabled = false;
                btn14443BReqAll.Enabled = false; btn14443BAnticollAllAFI.Enabled = false;
                btn14443BReqIdel.Enabled = false; btn14443BReqAllAFI.Enabled = false;
            };
            fCmdRet = StaticClassReaderB.ISO14443BAnticoll(ref readerAddr, Mode, AFI, PUPI, AppData, ProtocolInfo, ref errorCode, portFrmIndex);
            {
                btn14443BAnticollIdelAFI.Enabled = true; btn14443BReqIdelAFI.Enabled = true;
                btn14443BAnticollIdel.Enabled = true; btn14443BSelect.Enabled = true;
                btn14443BCloseRF.Enabled = true; btn14443BSendTrspCmd.Enabled = true;
                btn14443BHalt.Enabled = true; 
                btn14443BOpenRF.Enabled = true; btn14443BAnticollAll.Enabled = true;
                btn14443BReqAll.Enabled = true; btn14443BAnticollAllAFI.Enabled = true;
                btn14443BReqIdel.Enabled = true; btn14443BReqAllAFI.Enabled = true;
            }
            if (fCmdRet == 0)
            {
                tb14443BPUPI2.Text = ByteArrayToHexString(PUPI).Replace(" ", "");
                tb14443BAppData2.Text = ByteArrayToHexString(AppData).Replace(" ", "");
                tb14443BProtocolInfo2.Text = ByteArrayToHexString(ProtocolInfo).Replace(" ", "");
            }
            AddCmdLog(((Button)(sender)).Text, fCmdRet, errorCode);
        }

        private void btn14443BHalt_Click(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;

            fCmdRet = StaticClassReaderB.ISO14443BHalt(ref readerAddr, PUPI, ref errorCode, portFrmIndex);
            AddCmdLog(((Button)(sender)).Text, fCmdRet, errorCode);
        }

        private void btn14443BSelect_Click(object sender, EventArgs e)
        {
            byte param1, param2, param3, param4, errorCode = 0;
            byte TransmitionDelay, SubCarrierOnDelay;
            byte PICCToPCDRate, PCDToPICCRate;
            byte CIDO = 0, MBLI = 0, CID;
            byte[] PUPI1 = new byte[4];
            int fCmdRet = 0x30;

            param1 = 0;
            param2 = 0;
            param3 = 0;
            param4 = 0;
            tb14443BCID.Clear();
            tb14443BMBLI.Clear();
            if ((ckb14443BEOFBreak.Checked) &&
                (ckb14443BSOFBreak.Checked))
                param1 = 3;
            else if ((!ckb14443BEOFBreak.Checked) &&
                     (ckb14443BSOFBreak.Checked))
                param1 = 1;
            else if ((ckb14443BEOFBreak.Checked) &&
                     (!ckb14443BSOFBreak.Checked))
                param1 = 2;
            else if ((!ckb14443BEOFBreak.Checked) &&
                     (!ckb14443BSOFBreak.Checked))
                param1 = 0;
            TransmitionDelay = (byte)cbb14443BPCDDelay.SelectedIndex;
            SubCarrierOnDelay = (byte)cbb14443BPCDTransDataDelay.SelectedIndex;
            param2 = (byte)((SubCarrierOnDelay << 4) | TransmitionDelay);
            param3 = (byte)(cbb14443BPCDRcvMaxLen.SelectedIndex + 2);
            PICCToPCDRate = (byte)cbb14443BSpeedTToR.SelectedIndex;
            PCDToPICCRate = (byte)cbb14443BSpeedRToT.SelectedIndex;
            param4 = (byte)((PICCToPCDRate << 4) | PCDToPICCRate);
            if (tb14443BPUPI3.Text.Length == 8)
                PUPI = HexStringToByteArray(tb14443BPUPI3.Text.Replace(" ", ""));
            else
            {
                MessageBox.Show("Invalid PUPI");
                return;
            }
            CID = (byte)cbb14443BCID.SelectedIndex;
            fCmdRet = StaticClassReaderB.ISO14443BSelect(ref readerAddr, PUPI, CID, param1, param2, param3, param4,
                                                ref CIDO, ref MBLI, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                tb14443BCID.Text = " " + Convert.ToString(CIDO, 16);
                tb14443BMBLI.Text = " " + Convert.ToString(MBLI, 16);
            }
            AddCmdLog(((Button)(sender)).Text, fCmdRet, errorCode);
        }

        private void btn14443BSendTrspCmd_Click(object sender, EventArgs e)
        {
            byte Time_M, Time_N, CMD_Length, RSP_Length;
            byte errorCode = 0;
            string CMDString;
            byte[] CMD_Data = new byte[63];
            byte[] RSP_Data = new byte[100];
            int fCmdRet = 0x30;

            tb14443BResponeData.Clear();
            CMD_Length = (byte)(cbb14443BTrspCMDLen.SelectedIndex + 1);
            RSP_Length = (byte)cbb14443BTrspRSPLen.SelectedIndex;
            Time_M = (byte)cbb14443BTimeM.SelectedIndex;
            Time_N = (byte)cbb14443BTimeN.SelectedIndex;

            CMDString = tb14443BTrspCmd.Text.Replace(" ", "");
            if (CMDString == "")
            {
                MessageBox.Show("cmd data too short");
                return;
            }
            if (CMDString.Length > 126)
            {
                MessageBox.Show("cmd data too long");
                return;
            }

            if ((byte)(CMDString.Length / 2) != CMD_Length)
            {
                MessageBox.Show("length of command data different from set value");
                return;
            }

            CMD_Data = HexStringToByteArray(CMDString);

            fCmdRet = StaticClassReaderB.ISO14443BTransparentCmd(ref readerAddr, Time_M, Time_N, CMD_Length, RSP_Length,
                               CMD_Data, RSP_Data, ref errorCode, portFrmIndex);
            if (fCmdRet == 0)
            {
                Array.Resize(ref RSP_Data, RSP_Length);
                tb14443BResponeData.Text = ByteArrayToHexString(RSP_Data);
            }
            AddCmdLog("Transparent Cmd", fCmdRet, errorCode);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            tb14443BTrspCmd.Clear();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            tb14443BResponeData.Clear();
        }

        private void tb14443BTrspCmd_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789ABCDEF\b ".IndexOf(char.ToUpper(e.KeyChar)) < 0;  //  "\b"˸
        }

        private void tbReaderAddr_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789ABCDEF\b".IndexOf(char.ToUpper(e.KeyChar)) < 0;  //  "\b"˸
        }


        private void cbUIDListforInfo_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnGetSystemInfo.Enabled = true;
            btnResetToReady.Enabled = true;
            btnSelect.Enabled = true;
            btnGetSystemInfo.Enabled = true;
            btnLockAFI.Enabled = true;
            btnWriteAFI.Enabled = true;
            btnLockDSFID.Enabled = true;
            btnWriteDSFID.Enabled = true;
            btnStayQuite.Enabled = true;
        }

        private void button38_Click(object sender, EventArgs e)
        {
            Form helpFrm = new Form();
            PictureBox pictbFormula = new PictureBox();
            ResourceManager rm = new ResourceManager("HFReaderDemoCSharp.myResources", Assembly.GetExecutingAssembly());
            Bitmap bmp = (Bitmap)rm.GetObject("formal");
            pictbFormula.Image = (Image)bmp;
            pictbFormula.Height = pictbFormula.Image.Height;
            pictbFormula.Width = pictbFormula.Image.Width;
            helpFrm.Height = pictbFormula.Height + 40;
            helpFrm.Width = pictbFormula.Width;
            helpFrm.MaximizeBox = false;
            helpFrm.Text = "Information";
            helpFrm.FormBorderStyle = FormBorderStyle.FixedDialog;
            helpFrm.Controls.Add(pictbFormula);
            helpFrm.StartPosition = FormStartPosition.CenterScreen;
            helpFrm.Show();
        }

        private void cbb15693StartBlokNum_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbb15693BlockSize.Items.Count != 0)
                btnReadMultiBlock.Enabled = true;
        }

        private void btn14443ARWWrite_Click(object sender, EventArgs e)
        {
            byte block = 0, errorCode = 0;
            byte[] data = new byte[16];
            int fCmdRet = 0x30;

            if (cbb14443ARWSector.SelectedIndex > 32)
                block = (byte)(128 + (cbb14443ARWSector.SelectedIndex - 32) * 16 + cbb14443ARWBlockNumber.SelectedIndex);
            else
                block = (byte)(cbb14443ARWSector.SelectedIndex * 4 + cbb14443ARWBlockNumber.SelectedIndex);

            if ((cbb14443ARWSector.SelectedIndex < 32 && cbb14443ARWBlockNumber.SelectedIndex == 3) ||
                (cbb14443ARWSector.SelectedIndex >= 32 && cbb14443ARWBlockNumber.SelectedIndex == 15))
            {
                if (tb14443AKeyBlock.Text.Length != 32)
                {
                    MessageBox.Show("Input correct data");
                    return;
                }
                data = HexStringToByteArray(tb14443AKeyBlock.Text);
            }
            else
            {
                if (tb14443ADataBlock.Text.Length != 32)
                {
                    MessageBox.Show("Input correct data");
                    return;
                }
                data = HexStringToByteArray(tb14443ADataBlock.Text);
            }

            fCmdRet = StaticClassReaderB.ISO14443AWrite(ref readerAddr, block, data, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443ARWWrite.Text, fCmdRet);
        }

        private void btn14443AChangeKey_Click(object sender, EventArgs e)
        {
            byte block = 0, errorCode = 0;
            byte[] data = new byte[16];
            byte[] temp = new byte[6];
             
            int fCmdRet = 0x30;

            if(tb14443AKeyToWrite.Text.Replace(" ","").Length  != 12) //жԿǷ.
            {
                MessageBox.Show("ker error");
                return;
            }

            if (cbb14443ARWSector.SelectedIndex >= 32)
                block = (byte)(128 + (cbb14443ARWSector.SelectedIndex - 32) * 16 + 15);

            else
                block = (byte)(cbb14443ARWSector.SelectedIndex * 4 + 3);

            fCmdRet = StaticClassReaderB.ISO14443ARead(ref readerAddr, block, data, ref errorCode, portFrmIndex);

            if (fCmdRet == 0)
            {
                temp = HexStringToByteArray(tb14443AKeyToWrite.Text);
                if (radioButton2.Checked)       //޸ԿA
                    Array.Copy(temp, 0, data, 0, 6);
                else                            //޸ԿB
                    Array.Copy(temp, 0, data, 10, 6);
                fCmdRet = StaticClassReaderB.ISO14443AWrite(ref readerAddr, block, data, ref errorCode, portFrmIndex);
                
            }
            HFReaderStatusBar.Panels[0].Text = "";
            if (fCmdRet == 0)
                HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                 btn14443AChangeKey.Text + ": success";
            else if (fCmdRet == 0x30)
                HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                 btn14443AChangeKey.Text + ": Communication Error";
            else
            {
                HFReaderStatusBar.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                                 btn14443AChangeKey.Text + ": failed";
            }
       }

        private void btn14443AHalt2_Click_1(object sender, EventArgs e)
        {
            int fCmdRet = 0x30;
            byte errorCode = 0;

            fCmdRet = StaticClassReaderB.ISO14443AHalt(ref readerAddr, ref errorCode, portFrmIndex);

            AddCmdLog(btn14443AHalt2.Text, fCmdRet, errorCode);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            byte errorCode = 0, keyStyle = 0, accessSector;
            byte[] key = new byte[6];
            string temp;
            int fCmdRet = 0x30;

            if (rb14443AKeyA.Checked)
                keyStyle = 0;
            else if (rb14443AKeyB.Checked)
                keyStyle = 1;
            accessSector = (byte)cbbSector2.SelectedIndex;
            temp = tb14443AAuthKey.Text;
            if ((temp != "") &&
                (temp.Length == 12))
                key = HexStringToByteArray(temp);
            else
            {
                MessageBox.Show(" a invalid key");
                return;
            }
            fCmdRet = StaticClassReaderB.ISO14443AAuthKey(ref readerAddr, keyStyle, accessSector, key, ref errorCode, portFrmIndex);

            AddCmdLog("AuthKey", fCmdRet, errorCode);
        }

        private void button21_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            string str = "";
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            byte[] data = new byte[1024];
            ListViewItem aListItem = new ListViewItem();
            try
            {
                Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                EndPoint ep = (EndPoint)iep;
                sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                string request = "X";//ʼҪ͵
                byte[] buffer = Encoding.ASCII.GetBytes(request);
                sock.SendTo(buffer, iep);
                for (int i = 0; i < 255; i++)
                {
                    byte[] buffer1 = new byte[1000];
                    sock.ReceiveTimeout = 10;
                    int m_count = sock.ReceiveFrom(buffer1, ref ep);
                    if (m_count > 0)
                    {
                        aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        byte[] buffer2 = new byte[m_count];
                        Array.Copy(buffer1, buffer2, m_count);
                        string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                        if (fRecvIDPstring.Substring(0, 1) == "A")
                        {
                            int m = fRecvIDPstring.IndexOf('/');
                            Information.mac = fRecvIDPstring.Substring(1, m - 1);
                            Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                            m = fRecvIDPstring.IndexOf('*');
                            int n = fRecvIDPstring.Length - m - 8;
                            string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                            if (IDPstring != "")
                            {
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                            }
                            else
                            {
                                Information.usename = "";
                                Information.dsname = "";
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                str = "";
                            }
                            aListItem.SubItems[1].Text = Information.mac;
                            aListItem.SubItems[2].Text = Information.IP;
                            aListItem.SubItems[3].Text = str;
                        }
                    }
                }
                sock.Close();
            }
            catch (System.Exception ex)
            {
                ex.ToString();
                return;
            }
        }

        private void button23_Click(object sender, EventArgs e)
        {
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            locateForm loginform = new locateForm();
            DialogResult result = loginform.ShowDialog();
            if (result == DialogResult.OK)
            {
                try
                {
                    string IPAddr = loginform.IP1 + "." + loginform.IP2 + "." + loginform.IP3 + "." + loginform.IP4;
                    listView1.Items.Clear();
                    string str = "";
                    byte[] data = new byte[1024];
                    ListViewItem aListItem = new ListViewItem();
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    // IPAddress broadcast = IPAddress.Parse(IPAddr);
                    // IPEndPoint iep = new IPEndPoint(broadcast, 65535);
                    IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    for (int i = 0; i < 255; i++)
                    {
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        iep = new IPEndPoint(IPAddress.Parse(IPAddr), 65535);
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('/');
                                Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                m = fRecvIDPstring.IndexOf('*');
                                int n = fRecvIDPstring.Length - m - 8;
                                string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                                if (IPAddr == Information.IP)
                                {
                                    aListItem.SubItems[1].Text = Information.mac;
                                    aListItem.SubItems[2].Text = Information.IP;
                                    aListItem.SubItems[3].Text = str;
                                }
                            }
                            break;
                        }

                    }
                    sock.Close();
                }
                catch (System.Exception ex)
                {
                    ex.ToString();
                }
            }
            loginform.Dispose();
        }

        private void button24_Click(object sender, EventArgs e)
        {
            int i = 0;
            string IPaddr = "";
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    IPaddr = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    sock.EnableBroadcast=true;
                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(IPaddr), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    bool findflag = false;
                   
                    while (i < 255)
                    {
                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                            if(Information.IP==IPaddr)
                            {
                                findflag = true;
                                byte[] buffer2 = new byte[m_count];
                                Array.Copy(buffer1, buffer2, m_count);
                                string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                                if (fRecvIDPstring.Substring(0, 1) == "A")
                                {
                                    int m = fRecvIDPstring.IndexOf('/');
                                    Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                    Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                    m = fRecvIDPstring.IndexOf('*');
                                    int n = fRecvIDPstring.Length - m - 8;
                                    string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                    Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                    Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                    Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                    break;
                                }
                            }
                            
                        }
                        i = i + 1;
                    }
                    if (findflag==false)
                    {
                        return;
                    }      
                    i = 0;
                    request = "W" + Information.mac;//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }
                    
                    i = 0;
                    request = "L";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GON|1";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "1")
                                {
                                    Information.usename = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDN|2";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "2")
                                {
                                    Information.dsname = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFE|3";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "3")
                                {
                                    Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GIP|4";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "4")
                                {
                                    Information.IP = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPN|5";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "5")
                                {
                                    Information.portnum = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GTP|6";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "6")
                                {
                                    Information.tup = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRM|7";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "7")
                                {
                                    Information.rm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCM|8";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "8")
                                {
                                    Information.cm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCT|9";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "9")
                                {
                                    Information.ct = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFC|10";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "10")
                                {
                                    Information.fc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDT|11";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "11")
                                {
                                    Information.dt = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBR|12";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "12")
                                {
                                    Information.br = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPR|13";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "13")
                                {
                                    Information.pr = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBB|14";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "14")
                                {
                                    Information.bb = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRC|15";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "15")
                                {
                                    Information.rc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GML|16";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "16")
                                {
                                    Information.ml = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GMD|17";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "17")
                                {
                                    Information.md = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDI|18";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "18")
                                {
                                    Information.di = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDP|19";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "19")
                                {
                                    Information.dp = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GGI|20";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "20")
                                {
                                    Information.gi = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GNM|21";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "21")
                                {
                                    Information.nm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    if ((Information.nm == "") || (Information.mac == "") || (Information.IP == "") || (Information.portnum == "") ||
                        (Information.br == "") || (Information.bb == "") || (Information.dt == "") || (Information.rm == "") ||
                        (Information.tup == "") || (Information.pr == "") || (Information.fc == "") || (Information.di == "") || (Information.dp == "") || (Information.gi == ""))
                    {
                        MessageBox.Show("Please check device and PC connection status!", "Information");
                        return;
                    }
                    fSetdlg fsetdlg = new fSetdlg();
                    fsetdlg._IP(Information.IP);
                    fsetdlg._bb(Information.bb);
                    fsetdlg._br(Information.br);
                    fsetdlg._di(Information.di);
                    fsetdlg._dp(Information.dp);
                    fsetdlg._dsname(Information.dsname);
                    fsetdlg._dt(Information.dt);
                    fsetdlg._fc(Information.fc);
                    fsetdlg._gi(Information.gi);
                    fsetdlg._MAC(Information.mac);
                    fsetdlg._nm(Information.nm);
                    fsetdlg._portnum(Information.portnum);
                    fsetdlg._pr(Information.pr);
                    fsetdlg._rm(Information.rm);
                    fsetdlg._tup(Information.tup);
                    fsetdlg._usename(Information.usename);
                    DialogResult result = fsetdlg.ShowDialog();
                    if (result == DialogResult.OK)
                    {
                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|37";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(500);

                        iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                        sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);

                        request = "W" + Information.mac;//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);

                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        listView1.Items.Clear();
                    }
                    fsetdlg.Dispose();
                    sock.Close();
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void button25_Click(object sender, EventArgs e)
        {
            string IPAddr = "";
            ChangeIPdlg changeIPdlg = new ChangeIPdlg();
            DialogResult result = changeIPdlg.ShowDialog();
            if (result == DialogResult.OK)
            {
                IPAddr = changeIPdlg.IP1 + "." + changeIPdlg.IP2 + "." + changeIPdlg.IP3 + "." + changeIPdlg.IP4;
            }
            else
            {
                return;
            }
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Information.mac = listView1.SelectedItems[0].SubItems[1].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    //   sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(10);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(200);

                    iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);
                    request = "W" + Information.mac;
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    sock.Close();
                    listView1.Items.Clear();
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }

            }
            catch (Exception ex)
            {
                ex.ToString();
            }
            changeIPdlg.Dispose();
        }

        private void button26_Click(object sender, EventArgs e)
        {
            int i = 0;
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP

                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "B";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            i = 3;
                            sock.Close();
                            break;
                        }
                        i = i + 1;
                    }
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void OpenNetPort_Click(object sender, EventArgs e)
        {
            int port, openresult = 0;
            string IPAddr;
            if (textBox9.Text == "")
                textBox9.Text = "FF";
            readerAddr = Convert.ToByte(textBox9.Text, 16); // $FF;
            if ((textBox7.Text == "") || (textBox8.Text == ""))
                MessageBox.Show("Config error!", "information");
            port = Convert.ToInt32(textBox7.Text);
            IPAddr = textBox8.Text;
            openresult = StaticClassReaderB.OpenNetPort(port, IPAddr, ref readerAddr, ref portFrmIndex);
            if (openresult == 0)
            {
                EnableButton();
                btnGetReaderInfo_Click(null, null);
                fopencomport = portFrmIndex;
            }
            if ((openresult == 0x35) || (openresult == 0x30))
            {
                MessageBox.Show("TCPIP error", "Information");
             //   StaticClassReaderB.CloseNetPort(frmcomportindex);
            //    ComOpen = false;
                return;
            }
        }

        private void CloseNetPort_Click(object sender, EventArgs e)
        {
            if (portFrmIndex>1023)
            {
                int fCmdRet = StaticClassReaderB.CloseNetPort(portFrmIndex);
                if (fCmdRet == 0)
                {
                    portFrmIndex = -1;
                    fopencomport = -1;
                    ClearReaderInfo();
                    SystemClear();
                    HFReaderStatusBar.Panels[1].Text = "Port closed";
                    DisableButton();
                }
            }
            
        }

        private void tabControl2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ((fopencomport > 0) &&(fopencomport<256))
            {
                btnCloseComPort_Click(null,null);
            }
            else if (fopencomport>1023)
            {
                CloseNetPort_Click(null, null);
            }
        }
    }
}



